// NSDemo2.java

import java.util.*;
    
public class NSDemo2
{
   public static void main (String [] args)
   {
      // Create a NavigableSet.

      NavigableSet<String> ns = new TreeSet<String> ();

      // Populate the NavigableSet.

      String [] planets =
      {
         "Mercury",
         "Venus",
         "Earth",
         "Mars",
         "Jupiter",
         "Saturn",
         "Uranus",
         "Neptune"
      };

      for (String planet: planets)
           ns.add (planet);

      // View the elements in ascending order.

      System.out.println ("Ascending order view");
      System.out.println ();

      Iterator iter = ns.iterator ();
      while (iter.hasNext ())
         System.out.println (iter.next ());

      System.out.println ();

      // Exercise the ceiling/floor/higher/lower methods.

      exerciseCFHL (ns, "Mars");

      // View the elements in descending order.

      System.out.println ("Descending order view");
      System.out.println ();

      iter = ns.descendingIterator ();
      while (iter.hasNext ())
         System.out.println (iter.next ());

      System.out.println ();

      // Exercise the ceiling/floor/higher/lower methods.

      exerciseCFHL (ns.descendingSet (), "Mars");
   }

   public static void exerciseCFHL (NavigableSet<String> ns, String planet)
   {
      // View the least element in the set greater than or equal to planet.

      System.out.println ("ceiling('" + planet + "') = " + ns.ceiling (planet));

      // View the greatest element in the set less than or equal to planet.

      System.out.println ("floor('" + planet + "') = " + ns.floor (planet));

      // View the least element in the set higher than planet.

      System.out.println ("higher('" + planet + "') = " + ns.higher (planet));

      // View the greatest element in the set lower than planet.

      System.out.println ("lower('" + planet + "') = " + ns.lower (planet));

      System.out.println ();
   }
}
