// ScriptDemo2.java

import javax.script.*;

public class ScriptDemo2
{
   public static void main (String [] args) throws ScriptException
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Execute a script that does not return an object.

      Object o = engine.eval ("println ('Hello, World')");
      System.out.println ("Object value: " + o);

      // Obtain the engine's factory so the getOutputStatement() method can be 
      // invoked.

      ScriptEngineFactory factory = engine.getFactory ();

      // Obtain a JavaScript output statement that can output Hello, World --
      // output both the statement and the statement's output.

      String stmt = factory.getOutputStatement ("Hello, World");
      System.out.println (stmt);
      engine.eval (stmt);
      System.out.println ();

      // Execute a script that returns an object, output the object, and prove 
      // that the object is a Double (by outputting true).

      o = engine.eval ("1 + 3");
      System.out.println ("Object value: " + o);
      System.out.println ("Is double: " + (o instanceof Double));

      // Build and execute a script in a convenient manner.

      String [] program =
      {
         "var diameter = 20",
         "var pi = 3.14159",
         "println (\"Circumference = \" + (pi * diameter))"
      };

      engine.eval (factory.getProgram (program));
   }
}
