// Tokens.java

import java.util.*;

public class Tokens
{
   public static void main (String [] args)
   {
      Deque<String> deque = new ArrayDeque<String> ();

      tokenize (deque, "The quick brown fox jumped over the lazy dog");

      output ("Deque-based queue", deque);

      Queue<String> queue = Collections.asLifoQueue (deque);

      tokenize (queue, "The quick brown fox jumped over the lazy dog");

      output ("Deque-view queue", queue);
   }

   static void output (String title, Queue queue)
   {
      System.out.println (title);
      System.out.println ();

      int size = queue.size ();

      for (int i = 0; i < size; i++)
           System.out.println (queue.remove ());

      System.out.println ();
   }

   static void tokenize (Queue<String> queue, String s)
   {
      StringTokenizer st = new StringTokenizer (s);

      while (st.hasMoreTokens ())
         queue.add (st.nextToken ());
   }
}
